﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TesterClasses;

namespace Tester
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private int currentQuestion = 0;
        private DateTime time;
        private bool manyAnswers = false;
        
        //number is zero-based
        private void NextQuestion(int number)
        {
            CurrentQuestionStatus.Text = "Текущий вопрос: " + (currentQuestion + 1);
            /////////////////////////////////////////////
            //QuestionLabel.Text = Program.questions[number].Text;
            string[] delimiters = {@"\n"};
            string[] strings = Program.questions[number].Text.Split(delimiters, StringSplitOptions.RemoveEmptyEntries);
            questionTextBox.Lines = strings;
            for (int i = 0; i < Program.questions[number].Count; i++)
            {
                //RadioButton b = new RadioButton();
                ButtonBase b;
                if (Program.questions[currentQuestion].NumberOfAnswers == 1)
                {
                    manyAnswers = false;
                    b = new RadioButton();
                }
                else
                {
                    manyAnswers = true;
                    b = new CheckBox(); 
                }
                b.Size = new Size(85, 17);
                b.AutoSize = true;
                b.Location = new Point(10, 20 + 23 * i);
                b.Tag = i;
                b.Text = Program.questions[number][i].Text;
                ChoiceBox.Controls.Add(b);
            }
        }

        private void ShowStatistics(TestResults result)
        {
            Stats statistics = new Stats();
            statistics.ShowResults(result);
            statistics.ShowDialog(this);
        }

        private void EndTest()
        {
            //MessageBox.Show(Program.rightAnswers.ToString());
            TestResults result = new TestResults(Program.questions.TestName, Program.questions.Count,
                                                  Program.rightAnswers, time, DateTime.Now - time);
            if (Program.profile != null)
            {
                Program.profile.AddTestResult(result);
                Program.profile.SaveAllDataToFile();
            }
            Program.rightAnswers = 0;
            CurrentQuestionStatus.Text = "";
            RightQuestionsStatus.Text = "";
            menuStrip1.Enabled = true;
            ShowStatistics(result);
        }

        private void loadTestToolStripMenuItem_Click(object sender, EventArgs e)
        {
            /*Program.questions.LoadFromXml("NewQuestion.xml");*/
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                Program.questions = new Questions();
                Program.questions.LoadFromXml(openFileDialog1.FileName);
                NumberOfQuestionsStatus.Text = "Вопросов в тесте: " + Program.questions.Count.ToString();
                menuStrip1.Items[2].Enabled = true;
            }
        }

        private void beginTestToolStripMenuItem_Click(object sender, EventArgs e)
        {
            menuStrip1.Enabled = false;
            currentQuestion = 0;
            RightQuestionsStatus.Text = "Правильных ответов: 0";
            time = DateTime.Now;
            NextQuestion(currentQuestion);
        }
        //Интересно, а то, что при выходе из цикла с помощью goto
        //переменная current не обнуляется, не может ли привести к ошибке
        //в следующий раз?
        //Надо проверить.
        private void AnswerButton_Click(object sender, EventArgs e)
        {
            if (!manyAnswers)
            {
                foreach (Control c in ChoiceBox.Controls)
                {
                    if (((RadioButton)c).Checked)
                    {
                        if (Program.questions[currentQuestion][(int)c.Tag].IsTrue)
                            Program.rightAnswers++;
                        //goto AfterForeach;
                    }
                }
            }
            else
            {
                int numOfAns = 0;
                foreach (Control c in ChoiceBox.Controls)
                {
                    if (((CheckBox)c).Checked)
                        if (Program.questions[currentQuestion][(int)c.Tag].IsTrue)
                            ++numOfAns;
                }
                if (numOfAns == Program.questions[currentQuestion].NumberOfAnswers)
                    Program.rightAnswers++;
            }
            //AfterForeach:
            ChoiceBox.Controls.Clear();
            currentQuestion++;
            RightQuestionsStatus.Text = "Правильных ответов: " + Program.rightAnswers;
            if (currentQuestion < Program.questions.Count)
                NextQuestion(currentQuestion);
            else
                EndTest();
        }

        private void newProfileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ProfileManager profileManager = new ProfileManager();
            profileManager.ShowDialog(this);
            if (profileManager.DialogResult == DialogResult.OK)
                UserNameStatus.Text = "Пользователь: " + Program.profile.Name;
        }

        private void loadProfileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            /*Program.profile.Filename = "Ivan.xml";
            Program.profile.LoadFromFile();
            Program.profile.SaveAllDataToFile();*/
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                Program.profile.Filename = string.Copy(openFileDialog1.FileName);
                Program.profile.LoadFromFile();
                UserNameStatus.Text = "Пользователь: " + Program.profile.Name;
            }
        }

        private void closeProfileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Program.profile = null;
        }
    }
}