﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Xml;



namespace TesterClasses
{
    public class Profile : IEnumerable, IEnumerator
    {
        private string _name;
        private string _grade;
        private string _filename;
        private List<TestResults> _results = new List<TestResults>();
        
        public Profile()
        { }

        public Profile(string filename)
        {
            _filename = filename;
            //LoadFromFile();
        }

        public Profile(string name, string grade, string filename)
        {
            _name = name;
            _grade = grade;
            _filename = filename;
        }

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public string Grade
        {
            get { return _grade; }
            set { _grade = value; }
        }

        public string Filename
        {
            get { return _filename; }
            set
            {
                _filename = value;
            }
        }

        public int Count
        {
            get { return _results.Count; }
        }

        public TestResults this[int pos]
        {
            get { return _results[pos]; }
        }

        public void Remove(TestResults tr)
        {
            _results.Remove(tr);
        }

        public void AddTestResult(TestResults result)
        {
            _results.Add(result);
        }

        /*public void LoadFromFile()
        {

        }*/

        private void SaveToFile(XmlTextWriter writer)
        {  
            foreach (TestResults i in _results)
            {
                writer.WriteStartElement("TestResult");
                writer.WriteStartElement("TestName");
                writer.WriteString(i.testName);
                writer.WriteEndElement();
                writer.WriteStartElement("NumberOfQuestions");
                writer.WriteString(i.numberOfQuestions.ToString());
                writer.WriteEndElement();
                writer.WriteStartElement("RightAnswers");
                writer.WriteString(i.rightAnswers.ToString());
                writer.WriteEndElement();
                writer.WriteStartElement("Time");
                writer.WriteString(i.time.ToString());
                writer.WriteEndElement();
                writer.WriteStartElement("Interval");
                //writer.WriteString(i.interval.TotalMinutes.ToString());
                writer.WriteString(i.interval.ToString());
                writer.WriteEndElement();
                writer.WriteEndElement();
            }
        }

        //сохраняет всю информацию
        public void SaveAllDataToFile()
        {
            System.IO.File.Delete(_filename);
            XmlTextWriter writer = new XmlTextWriter(_filename, System.Text.Encoding.Unicode);
            writer.Formatting = Formatting.Indented;
            writer.WriteStartDocument();
            writer.WriteStartElement("Profile");
            //writer.WriteElementString("Name", _name);
            writer.WriteStartElement("Information");
            writer.WriteStartElement("Name");
            writer.WriteString(_name);
            writer.WriteEndElement();
            //writer.WriteElementString("Grade", _grade);
            writer.WriteStartElement("Grade");
            writer.WriteString(_grade);
            writer.WriteEndElement();
            writer.WriteEndElement();
            writer.WriteStartElement("TestResults");
            SaveToFile(writer);
            writer.WriteEndElement();
            writer.WriteEndElement();
            writer.WriteEndDocument();
            writer.Close();
        }

        /*public void LoadTestResults()
        {
            XmlTextReader reader = new XmlTextReader(_filename);
            reader.WhitespaceHandling = WhitespaceHandling.None;
            while (reader.Name != "Name")
                reader.Read();
            _name = reader.Value;
            while (reader.Name != "Grade")
                reader.Read();
            _grade = reader.Value;
            while (reader.Name != "TestResult")
                reader.Read();
            while (reader.Name != "TestResults")
            {
                TestResults result;
                result.testName = reader.Value;
                reader.Read();
                reader.Read();
                result.numberOfQuestions = int.Parse(reader.Value);
                reader.Read();
                reader.Read();
                result.rightAnswers = int.Parse(reader.Value);
                reader.Read();
                reader.Read();
                result.time = DateTime.Parse(reader.Value);
                reader.Read();
                reader.Read();
                result.interval = TimeSpan.Parse(reader.Value);
                reader.Read();
                reader.Read();
                reader.Read();
                _results.Add(result);
            }
            reader.Close();
        }*/

        public void LoadFromFile()
        {
            XmlDocument doc = new XmlDocument();
            doc.Load(_filename);
            XmlNodeList nlist = doc.GetElementsByTagName("Name");
            _name = nlist[0].InnerText;
            nlist = doc.GetElementsByTagName("Grade");
            _grade = nlist[0].InnerText;
            nlist = doc.GetElementsByTagName("TestResult");
            foreach (XmlNode node in nlist)
            {
                TestResults result = new TestResults();
                result.testName = node["TestName"].InnerText;
                result.numberOfQuestions = int.Parse(node["NumberOfQuestions"].InnerText);
                result.rightAnswers = int.Parse(node["RightAnswers"].InnerText);
                result.time = DateTime.Parse(node["Time"].InnerText);
                result.interval = TimeSpan.Parse(node["Interval"].InnerText);
                _results.Add(result);
            }
        }

        public IEnumerator GetEnumerator()
        {
            return (IEnumerator)this;
        }

        int position = -1;
        
        public object Current
        {
            get { return _results[position]; }
        }

        public bool MoveNext()
        {
            if (position < _results.Count - 1)
            {
                position++;
                return true;
            }
            else
            {
                position = -1;
                return false;
            }
        }

        public void Reset()
        {
            position = -1;
        }
    }
}
