﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Xml;

namespace TesterClasses
{
    //надо бы класс называть не Questions, а Test
    public class Questions : IEnumerable, IEnumerator
    {
        private List<Question> _questions = new List<Question>();
        private string _testName;

        public Questions()
        { }

        public void AddQuestion(string question)
        {
            Question temp = new Question(question, 0);
            _questions.Add(temp);
        }

        public void DeleteQuestion(int pos)
        {
            _questions.RemoveAt(pos);
        }

        public Question this[int pos]
        {
            get { return _questions[pos]; }
            set { _questions[pos] = value; }
        }

        public int Count
        {
            get { return _questions.Count; }
        }

        public string TestName
        {
            get { return _testName; }
            set { _testName = value; }
        }

        public void SaveToXml(string fileName)
        {
            XmlTextWriter writer = new XmlTextWriter(fileName, System.Text.Encoding.Unicode);
            writer.Formatting = Formatting.Indented;
            writer.WriteStartDocument();
            writer.WriteStartElement("Test");
            writer.WriteStartElement("TestName");
            writer.WriteString(_testName);
            writer.WriteEndElement();
            writer.WriteStartElement("Questions");
            foreach (Question q in _questions)
            {
                q.SaveToXml(writer);
            }
            writer.WriteEndElement();
            writer.WriteEndElement();
            writer.WriteEndDocument();
            writer.Close();
        }

        public void LoadFromXml(string fileName)
        {
            _questions.Clear();
            XmlTextReader reader = new XmlTextReader(fileName);
            reader.WhitespaceHandling = WhitespaceHandling.None;
            while (reader.Name != "TestName")
                reader.Read();
            _testName = reader.ReadInnerXml();
            while (reader.Name != "Question")
                reader.Read();
            while (reader.Name != "Questions")
            {
                AddQuestion("NewQuestion");
                _questions[_questions.Count - 1].LoadFromXml(reader);
                reader.Read();
            }
        }

        //IEnumerator and IEnumerable

        private int position = -1;

        public IEnumerator GetEnumerator()
        {
            return (IEnumerator)this;
        }

        public object Current
        {
            get { return _questions[position]; }
        }

        public bool MoveNext()
        {
            if (position < _questions.Count - 1)
            {
                position++;
                return true;
            }
            else
            {
                position = -1;
                return false;
            }
        }

        public void Reset()
        {
            position = -1;
        }
    }
}
