﻿using System;
using System.Xml;


namespace TesterClasses
{
    public struct TestResults
    {
        public DateTime time;
        public TimeSpan interval;
        public int rightAnswers;
        public int numberOfQuestions;
        public string testName;

        public TestResults(string testName, int numberOfQuestions,
                           int rightAnswers, DateTime time, TimeSpan interval)
        {
            this.testName = testName;
            this.numberOfQuestions = numberOfQuestions;
            this.rightAnswers = rightAnswers;
            this.time = time;
            this.interval = interval;
        }

        public void LoadFromXml(XmlNode node)
        {
            this.testName = node["TestName"].InnerText;
            this.numberOfQuestions = int.Parse(node["NumberOfQuestions"].InnerText);
            this.rightAnswers = int.Parse(node["RightAnswers"].InnerText);
            this.time = DateTime.Parse(node["Time"].InnerText);
            this.interval = TimeSpan.Parse(node["Interval"].InnerText);
        }

        public override string ToString()
        {
            return testName + "[delimiter]" + rightAnswers + "[delimiter]" + numberOfQuestions + "[delimiter]" +
                time.ToString() + "[delimiter]" + interval.ToString();
        }

        public static TestResults Parse(string s)
        {
            string[] tmp = s.Split(new string[] { "[delimiter]" }, StringSplitOptions.RemoveEmptyEntries);
            TestResults result = new TestResults();
            result.testName = tmp[0];
            result.rightAnswers = int.Parse(tmp[1]);
            result.numberOfQuestions = int.Parse(tmp[2]);
            result.time = DateTime.Parse(tmp[3]);
            result.interval = TimeSpan.Parse(tmp[4]);
            return result;
        }
    }
}
